import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import java.io.File; 
import gifAnimation.*; 
import sojamo.drop.*; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class dataPaint extends PApplet {








int nbFiles = 7;
byte[][] data = new byte[nbFiles][];
int currentFile=0;
int[] index = new int[nbFiles];
int brushSize=10;
PImage painting;
int prevX=0;
int prevY=0;
boolean firstPress=true;

int[][] fileIndex;
int[][] offsetIndex;

int dpSize = 20;

int nbTools = 4;
int selectedTool = 0;

SDrop drop;
DropSlot[] slots = new DropSlot[nbFiles];

public void setup() {
  frameRate(30);
  noSmooth();
  size(300, 300);
  background(0);
  painting = createImage(200, 200, RGB);
  fileIndex = new int[painting.width][painting.height];
  offsetIndex = new int[painting.width][painting.height];
  drop = new SDrop(this);
  for (int i=0;i<nbFiles;i++) {
    index[i]=0;
    slots[i] = new DropSlot(i);
    drop.addDropListener(slots[i]);
  }
  for (int x=0;x<painting.width;x++) {
    for (int y=0;y<painting.height;y++) {
      painting.set(x, y, color(0x00));
      fileIndex[x][y]=-1;
      offsetIndex[x][y]=-1;
    }
  }
  textSize(8);
}

public void draw() {  
  background(0);
  noFill();
  stroke(0x50);
  line(100, 50, 200, 50);
  stroke(0xFF);
  ellipse(100+brushSize*2, 50, brushSize, brushSize);
  for (int i=0;i<nbTools;i++) {
    noFill();
    if (i==selectedTool) stroke(0xFF);
    else stroke(0x50);
    pushMatrix();
    translate(100+i*20, 10);
    rect(0, 0, 15, 15);
    stroke(0x50);
    if (i==0) ellipse(7, 7, 9, 9);
    if (i==1) rect(3, 3, 9, 9);
    if (i==2) triangle(3, 3, 12, 3, 7, 12);
    if (i==3) {
      rect(3, 3, 9, 9);
      rect(5, 5, 5, 3);
    }
    popMatrix();
  }
  for (int i=0;i<data.length;i++) {
    noFill();
    stroke(0x50);
    if (i==currentFile) stroke(0xFF);
    rect(10, 10+i*(dpSize+10), dpSize, dpSize);
    if (data[i]==null) {
      text("<- drag and", 10+dpSize+5, 18+i*(dpSize+10));
      text("drop file here", 10+dpSize+5, 28+i*(dpSize+10));
    }
    for (int x=0;x<dpSize-1;x++) {
      for (int y=0;y<dpSize-1;y++) {
        if (data[i]!=null) stroke(data[i][(index[i]+(x+y*dpSize)*3+0)%data[i].length]&0xFF, data[i][(index[i]+(x+y*dpSize)*3+1)%data[i].length]&0xFF, data[i][(index[i]+(x+y*dpSize)*3+2)%data[i].length]&0xFF);
        else stroke(0x20);
        point(11+x, 11+i*(dpSize+10)+y);
      }
    }
  }
  if (mousePressed) {
    if (mouseX>100&&mouseX<200&&mouseY<=25) {
      if (floor(((float)mouseX-100)/20)<3) selectedTool=floor(((float)mouseX-100)/20);
      if (floor(((float)mouseX-100)/20)==3) export();
    }
    if (mouseX>100&&mouseX<200&&mouseY>40&&mouseY<60) {
      brushSize=floor(((float)mouseX-100)/2);
    }
    if (mouseX<dpSize+10) {
      currentFile = (floor((float)mouseY-10)/(dpSize+10))%data.length;
    }
    if (mouseX>=90&&mouseX<90+200&&mouseY>=90&&mouseY<90+200) {
      if (selectedTool==0||selectedTool==1) {
        if (prevX!=mouseX||prevY!=mouseY||firstPress) {
          firstPress=false;
          for (int x=-brushSize;x<brushSize;x++) {
            for (int y=-brushSize;y<brushSize;y++) {
              if (mouseX-90+x>=0&&mouseX-90+x<painting.width&&mouseY-90+y>=0&&mouseY-90+y<painting.height) {
                if (sq(x)+sq(y)<sq(brushSize)||selectedTool==1) {
                  if (data[currentFile]!=null) {
                    index[currentFile]=(index[currentFile]+3)%data[currentFile].length;
                    painting.set(mouseX-90+x, mouseY-90+y, color(data[currentFile][index[currentFile]%data[currentFile].length]&0xFF, data[currentFile][(index[currentFile]+1)%data[currentFile].length]&0xFF, data[currentFile][(index[currentFile]+2)%data[currentFile].length]&0xFF));
                    fileIndex[mouseX-90+x][mouseY-90+y]=currentFile;
                    offsetIndex[mouseX-90+x][mouseY-90+y]=index[currentFile];
                  }
                }
              }
            }
          }
        }
      }
      if (selectedTool==2) {
        fillWithFile(mouseX-90, mouseY-90);
      }
    }
  } 
  else {
    firstPress=true;
  }
  image(painting, 90, 90);
  noFill();
  stroke(0xA0);
  rect(90, 90, 200, 200);
  prevX=mouseX;
  prevY=mouseY;
}

public void dropEvent(DropEvent theDropEvent) {
  if (theDropEvent.isFile()) {
  }
  if (theDropEvent.isURL()) {
  }
}

class DropSlot extends DropListener {
  int index;
  DropSlot(int i) {
    this.index=i;
    setTargetRect(10, 10+i*(dpSize+10), dpSize, dpSize);
  }
  public void dropEvent(DropEvent theEvent) {
    currentFile=index;
    data[currentFile] = null;
    data[currentFile] = loadBytes(theEvent.file());
  }
}

boolean[][] fillDone;
public void fillWithFile(int xS, int yS) {
  fillDone = new boolean[fileIndex.length][fileIndex[0].length];
  for (int x=0;x<fileIndex.length;x++) {
    for (int y=0;y<fileIndex[x].length;y++) {
      fillDone[x][y]=false;
    }
  }
  int fillContBaseFileIndex = fileIndex[xS][yS];
  int changesDone=-1;
  while (changesDone!=0) {
    changesDone=0;
    for (int x=0;x<fileIndex.length;x++) {
      for (int y=0;y<fileIndex[x].length;y++) {
        if (!fillDone[x][y]) {
          if (fileIndex[x][y]==fillContBaseFileIndex) {
            boolean todo = false;
            if (x+1<fileIndex.length)     if (fillDone[x+1][y]) todo = true;
            if (y+1<fileIndex[0].length)  if (fillDone[x][y+1]) todo = true;
            if (x-1>=0)                   if (fillDone[x-1][y]) todo = true;
            if (y-1>=0)                   if (fillDone[x][y-1]) todo = true;
            if (x==xS&&y==yS) todo = true;
            if (todo) {
              fillDone[x][y]=true;
              index[currentFile]=(index[currentFile]+3)%data[currentFile].length;
              painting.set(x, y, color(data[currentFile][index[currentFile]%data[currentFile].length]&0xFF, data[currentFile][(index[currentFile]+1)%data[currentFile].length]&0xFF, data[currentFile][(index[currentFile]+2)%data[currentFile].length]&0xFF));
              fileIndex[x][y]=currentFile;
              offsetIndex[x][y]=index[currentFile];
              changesDone++;
            }
          }
        }
      }
    }
  }
}

public void export() {
  painting.save("result.png");
  PImage tmpPainting = painting.get(); 
  GifMaker gifExport = new GifMaker(this, "export.gif");
  gifExport.setRepeat(0);             // make it an "endless" animation
  gifExport.setTransparent(0, 0, 0);    // black is transparent
  int nbFrames = 20;
  for (int i=0;i<nbFrames;i++) {
    for (int x=0;x<painting.width;x++) {
      for (int y=0;y<painting.height;y++) {
        if (fileIndex[x][y]==-1) painting.set(x, y, color(0));
        else {
          int thisIndex = floor(offsetIndex[x][y]+(float)i/nbFrames*data[fileIndex[x][y]].length)%data[fileIndex[x][y]].length;
          painting.set(x, y, color(data[fileIndex[x][y]][(thisIndex+0)%data[fileIndex[x][y]].length]&0xFF, data[fileIndex[x][y]][(thisIndex+1)%data[fileIndex[x][y]].length]&0xFF, data[fileIndex[x][y]][(thisIndex+2)%data[fileIndex[x][y]].length]&0xFF));
        }
      }
    }    
    gifExport.addFrame(painting);
  }
  gifExport.finish();
  painting = tmpPainting;
}

  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "dataPaint" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
